import { Router } from 'express';
import axios from 'axios';
import { CONSTANTS_HB, TEXT_CONSTANTS } from '../constants';
import {
	Ticker,
	PayType,
	OrderStatus,
	Currency,
	User,
} from '../models_nosql';
import {
	handlerTotalBalance,
	getUserPayMethods,
	getMerchantAdvs,
	getMerchantOrders,
	getArraySortedByProp,
	getArrayFilteredByProp,
	getOrderDetails,
	getTickerPriceUSDT,
	checkOrderInDB,
	insertOrderToDB,
	getP2POrders,
	getSpotOrders,
	getP2POrdersNomalized,
	getMerchantAdvsNomalized,
	getMerchantOrdersNomalized,
	getSpotOrdersNomalized,
	getBalancesNormalized,
	getSingleUserProperty,
	getPropsCurrency,
	getPayMethodProps,
	getPayMethodPropsReverse,
	getPaySubAccount,
	consoleProcessed,
	getOrderDetailsNomalized,
	getObjectRequestParams,
} from '../common';
const {
	SHORT_NAME,
	GET_SPOT_BALANCE,
	GET_P2P_BALANCE,
	GET_FUT_BALANCE,
	GET_EARN_BALANCE,
	TRANSFER_ASSET_FROM_P2P,
	TRANSFER_ASSET_FROM_SPOT,
	GET_P2P_ORDERS,
	GET_MERCHANT_ORDERS,
	GET_MERCHANT_ORDER_DETAILS,
	GET_MERCHANT_ADVS,
	CHANGE_STATUS_ADVS,
	GET_ADV_DETAIL,
	UPDATE_DETAILS_ADV,
	GET_HISTORY_SPOT_ORDERS,
	GET_ACTIVE_SPOT_ORDERS,
	GET_MERCHANT_ADV_PAYMENTS,
	GET_MERCHANT_DETAILS,
} = CONSTANTS_HB;

export const ordersRouter_HB = Router();

// получение балансов
ordersRouter_HB.post('/get-balances', async (req, res) => {
	const { userId, exchangeId, shortName } = req.body;
	const user = await User.findOne({ _id: userId });

	const objParams = {
		userId,
		shortName,
		prefix: `balance_${shortName}_API`,
		// prefix: `balance_${shortName}`,
		constants: CONSTANTS_HB,
		apiKeys: getSingleUserProperty('apiKeys', exchangeId, user.properties),
		requestHeader: getSingleUserProperty(
			'requestHeader',
			exchangeId,
			user.properties
		),
		additionals: {},
	};

	const totalBalance = await handlerTotalBalance(objParams);

	return res.status(200).json({
		success:
			totalBalance.spotBalance.length === 0 ||
			totalBalance.p2pBalance.length === 0
				? false
				: true,
		balances: totalBalance,
		message:
			totalBalance.spotBalance.length === 0 ||
			totalBalance.p2pBalance.length === 0
				? `${shortName}: ${TEXT_CONSTANTS.BALANCE_ER}`
				: `${shortName}: ${TEXT_CONSTANTS.BALANCE_OK}`,
	});
});

// получение массива объявлений
ordersRouter_HB.post('/merchant-advs', async (req, res) => {
	const { userId, shortName, exchangeId, objParams } = req.body;
	const user = await User.findOne({ _id: userId });
	const requestHeaderHB = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const params = {
		userId,
		prefix: shortName,
		config: {
			withCredentials: true,
			method: GET_MERCHANT_ADVS.method,
			url: '',
			data: {},
			headers: {
				'access-control-allow-credentials': true,
				'Access-Control-Allow-Origin': '*',
				'content-type': 'application/json;charset=UTF-8',
				portal: 'web',
				token: requestHeaderHB.token,
				// "fingerprint":requestHeaderHB.fingerprint,
				// "trace_id":requestHeaderHB.traceId,
				'user-agent': requestHeaderHB.userAgent,
			},
		},
	};

	let arrData = [];
	for (let i = 1; i <= 2; i++) {
		params.config.url = `${GET_MERCHANT_ADVS.url}?currPage=${i}`;
		const result = await getMerchantAdvs(params);
		arrData = arrData.concat(result);
	}

	const arrPayTypes = await PayType.find();
	const arrCurrencies = await Currency.find();
	// console.log(arrData[0].payMethods);
	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		data: {
			merchantAdvs: [],
			merchantAdvs:
				arrData.length !== 0
					? getMerchantAdvsNomalized(
							arrData,
							{
								userId,
								exchangeId,
								prefix: shortName,
								arrCurrencies,
							},
							arrPayTypes
					  )
					: [],
			userPayMethods: [],
		},
		message:
			arrData.length !== 0
				? `${shortName}: ${TEXT_CONSTANTS.USER_ADVS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.USER_ADVS_ER}`,
	});
});

// изменение статуса объявления (-ий) мерчанта
ordersRouter_HB.post('/adv-status', async (req, res) => {
	res.status(400).json({
		error,
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_STATUS_ER}`,
	});
});

// получение редактируемого объявления мерчанта
ordersRouter_HB.post('/adv-edit', async (req, res) => {
	res.status(400).json({
		error,
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_EDIT_ER}`,
	});
});

// обновление редактируемого объявления
ordersRouter_HB.post('/adv-update', async (req, res) => {
	res.status(400).json({
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_UPDATE_ER}`,
	});
});

// получение массива p2p-ордеров стакана
ordersRouter_HB.post('/p2p', async (req, res) => {
	const { userId, exchangeId, shortName, objParams } = req.body;
	const { asset, fiat, arrPayments, page, sideType, amount } = objParams;

	const arrPayTypes = await PayType.find();
	const arrCurrencies = await Currency.find();
	const tradeType = sideType === 'BUY' ? 'sell' : 'buy';
	const assetID = getPropsCurrency(
		exchangeId,
		asset,
		'coin',
		arrCurrencies
	).coinId;
	const fiatID = getPropsCurrency(exchangeId, fiat, 'fiat', arrCurrencies)
		.coinId;

	const paymentIdx =
		arrPayments.length === 0
			? ['0']
			: arrPayments.map((item, index) => {
					return getPayMethodPropsReverse(
						exchangeId,
						'payId', // payId or payName
						item, // internalPayMethod
						arrPayTypes
					);
			  });
	const user = await User.findOne({ _id: userId });
	const requestHeaderHB = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const params = {
		userId,
		prefix: shortName,
		config: {
			// withCredentials: true,
			method: GET_P2P_ORDERS.method,
			url: '',
			data: null,
			headers: null,
			// headers: {
			// 	'access-control-allow-credentials': true,
			// 	'Access-Control-Allow-Origin': '*',
			// 	'content-type': 'application/json;charset=UTF-8',
			// 	'user-agent': requestHeaderHB.userAgent,
			// },
		},
	};

	let arrData = [];
	for (let i = 0; i < paymentIdx.length; i++) {
		const strURL = `coinId=${assetID}&currency=${fiatID}&tradeType=${tradeType}&currPage=${page}&payMethod=${paymentIdx[i]}&acceptOrder=-1&country=&blockType=general&online=1&range=0&amount=${amount}&isThumbsUp=false&isMerchant=false&isTraded=false&onlyTradable=false&isFollowed=false`;
		params.config.url = `${GET_P2P_ORDERS.url}?${strURL}`;
		const result = await getP2POrders(params);
		// console.log(params.config.url);
		arrData = arrData.concat(result);
	}

	// отсекаем дубли
	const arrUniqueData = getArrayFilteredByProp(arrData, 'id');
	// сортировка DESC or ASC
	const arrDataSorted = getArraySortedByProp(
		shortName,
		arrUniqueData,
		tradeType
	);

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		data: {
			// p2pOrders: [],
			p2pOrders:
				arrData.length !== 0
					? getP2POrdersNomalized(
							arrDataSorted,
							{
								userId,
								exchangeId,
								prefix: shortName,
								asset,
								fiat,
							},
							arrPayTypes
					  )
					: [],
			tickers: await Ticker.find(),
		},
		message:
			arrData.length !== 0
				? `${shortName}: ${arrData.length} ${TEXT_CONSTANTS.P2P_ORDERS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.P2P_ORDERS_ER}`,
	});
});

// получение массива текущих merchant-ордеров
ordersRouter_HB.post('/merchant-orders', async (req, res) => {
	const { userId, exchangeId, shortName } = req.body;

	const user = await User.findOne({ _id: userId });

	const params = {
		userId,
		prefix: `otc_${shortName}`,
		// prefix: `otc_${shortName}_API`,
		apiKeys: getSingleUserProperty('apiKeys', exchangeId, user.properties),
		requestHeader: getSingleUserProperty(
			'requestHeader',
			exchangeId,
			user.properties
		),
		constants: CONSTANTS_HB,
		additionals: {},
	};

	const objReqParams = getObjectRequestParams(params);
	const arrData = await getMerchantOrders(objReqParams);
	// console.log(arrData);
	const arrPayTypes = await PayType.find();
	const arrOrderStatus = await OrderStatus.find();

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		// data: [],
		data:
			arrData.length !== 0
				? getMerchantOrdersNomalized(
						arrData,
						{
							userId,
							exchangeId,
							prefix: shortName,
						},
						arrPayTypes,
						arrOrderStatus
				  )
				: [],
		message:
			arrData.length !== 0
				? `${shortName}: ${arrData.length} ${TEXT_CONSTANTS.USER_ORDERS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.USER_ORDERS_ER}`,
	});
});

// получение сведений об мерчанте и его объявлениях по id
ordersRouter_HB.get('/merchant-details/:id', async (req, res) => {
	const merchantId = req.params.id;
	const axiosRequestConfig = {
		method: GET_MERCHANT_DETAILS.method,
		url: `${GET_MERCHANT_DETAILS.url}?userNo=${merchantId}`,
		data: null,
		headers: null,
	};
	await axios(axiosRequestConfig)
		.then((response) => {
			// console.log(response.data)
			return res.status(200).json({
				success: true,
				data: response.data.data,
				message: `${SHORT_NAME}: ${TEXT_CONSTANTS.USER_DETAILS_OK}`,
			});
		})
		.catch((error) => {
			res.status(400).json({
				error,
				message: `${SHORT_NAME}: ${TEXT_CONSTANTS.USER_DETAILS_ER}`,
			});
		});
});

// сохранение данных об merchant-ордере в БД по id
ordersRouter_HB.post('/save-user-orders', async (req, res) => {
	const arrTickers = await Ticker.find(); // тикеры и цены из БД
	let countOrder = 0;

	const { userId, orders, typeOrder, shortName, exchangeId } = req.body;

	// проверка наличия ордера в БД
	for (let i = 0; i < orders.length; i++) {
		if (orders[i].statusProps.value === 'Completed') {
			const result = await checkOrderInDB(
				userId,
				typeOrder,
				orders[i].orderId,
				shortName
			);

			// Если ордера нет в БД
			if (result.isUnique) {
				const params = {
					userId,
					shortName,
					exchangeId,
					arrTickers,
					orderDetails: orders[i], // нормализованный ордер from frontend
				};

				const newOrder = getOrderDetailsNomalized(params);
				// если newOrder не пустой объект - сохраняем в БД
				if (Object.keys(newOrder).length !== 0) {
					await insertOrderToDB(typeOrder, newOrder);
					// console.log(newOrder);
					++countOrder;
				}
			}
		}
	}

	// log print
	consoleProcessed(userId, shortName, orders, countOrder, typeOrder);

	return res.status(200).json({
		success: true,
		message: `${shortName}: ${countOrder} inserted`,
	});
});

// получение массива активных spot-ордеров
ordersRouter_HB.post('/spot-orders-active', async (req, res) => {
	const { userId, exchangeId, shortName } = req.body;
	const arrTickers = await Ticker.find();
	let status = 200;

	const user = await User.findOne({ _id: userId });
	const requestHeader = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	// проверям существуют ли куки на этом сервисе
	if (requestHeader.userAgent === '') {
		return res.status(status).json({
			success: true,
			message: `${shortName}: requestHeader is empty`,
			spotOrders: [],
			tickers: await Ticker.find(),
		});
	}

	const paramsAPI = {
		userId,
		prefix: `active_${SHORT_NAME}`,
		// apiKeys,
		requestHeader,
		constants: CONSTANTS_HB,
		additionals: {},
	};

	const objReqParamsAPI = getObjectRequestParams(paramsAPI);
	const spotArray = await getSpotOrders(objReqParamsAPI);

	return res.status(status).json({
		success:
			arrActiveSpots === null || arrActiveSpots.length === 0
				? false
				: true,
		message:
			arrActiveSpots === null || arrActiveSpots.length === 0
				? `${shortName}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`
				: `${shortName}: ${arrActiveSpots.length} ${TEXT_CONSTANTS.SPOT_ORDERS_OK}`,
		spotOrders:
			arrActiveSpots === null || arrActiveSpots.length === 0
				? []
				: getSpotOrdersNomalized(
						arrActiveSpots,
						{
							userId,
							shortName: shortName,
							exchangeId,
							flag: `active_${SHORT_NAME}`,
						},
						arrTickers
				  ),
		tickers: await Ticker.find(),
	});
});

// сохранение spot-ордеров в БД
ordersRouter_HB.post('/spot-orders-history', async (req, res) => {
	let message;
	let success = true;
	let status = 200;
	let countOrder = 0;
	const {
		userId,
		exchange,
		exchangeId,
		shortName,
		typeOrder,
		params,
	} = req.body;

	const user = await User.findOne({ _id: userId });
	const requestHeader = getSingleUserProperty(
		'requestHeader',
		exchange,
		user.properties
	);

	const paramsAPI = {
		userId,
		prefix: `history_${SHORT_NAME}`,
		// apiKeys,
		requestHeader,
		constants: CONSTANTS_HB,
		additionals: { size: params.rows },
	};

	const objReqParamsAPI = getObjectRequestParams(paramsAPI);
	const spotArray = await getSpotOrders(objReqParamsAPI);

	// Если ордера не получены
	if (spotArray === null) {
		success = false;
		message = `${SHORT_NAME}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`;
		return res.status(status).json({
			success,
			message,
		});
	}

	const arrTickers = await Ticker.find();
	const spotOrders = getSpotOrdersNomalized(
		spotArray,
		{
			userId,
			shortName: SHORT_NAME,
			exchangeId,
			flag: `history_${SHORT_NAME}`,
		},
		arrTickers
	);

	if (spotOrders.length !== 0) {
		// проверка наличия ордера в БД
		for (let i = 0; i < spotOrders.length; i++) {
			const result = await checkOrderInDB(
				spotOrders[i].userId,
				typeOrder,
				spotOrders[i].orderId,
				spotOrders[i].exchange
			);

			// Если ордера нет в БД вставляем
			if (result.isUnique) {
				// если newSpotOrder не пустой объект - сохраняем в БД
				if (Object.keys(spotOrders[i]).length !== 0) {
					await insertOrderToDB('SPOT', spotOrders[i]);
					// console.log(
					// 	`${countOrder} | tradeIdStr: ${spotOrders[i].tradeIdStr} inserted`
					// );
					++countOrder;
				}
			}
			// else console.log(`Order ${spotOrders[i].orderId} is not Unique`);
		}
		if (countOrder === 0) {
			success = false;
			message = `${SHORT_NAME}: ${countOrder} | ${TEXT_CONSTANTS.SPOT_ORDERS_DB_NO}`;
		} else {
			success = true;
			message = `${SHORT_NAME}: ${countOrder} | ${TEXT_CONSTANTS.SPOT_ORDERS_DB_OK}`;
		}
	} else {
		success = false;
		message = `${SHORT_NAME}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`;
	}

	// log print
	consoleProcessed(userId, shortName, spotOrders, countOrder, typeOrder);

	return res.status(status).json({
		success,
		message,
	});
});
